	.LI OFF

;Contador ???
;NO DEBERIA LLEGAR AQUI ???
;LINEA ANADIDA -> ADDED LINE ?????
;ESPERA A QUE TERMINE SIGNAL ERROR ???

	.LI OFF
	.CR Z80
	.OR $E400-7
	.TF k7ldr.bin,BIN
               
	.DB $FE
	.DW $E400
	.DW FINISH
	.DW $E400

; DEFINITIONS OF CONSTANTS 
;__________________________



CONV_TABLE      .EQ     $E300	; address to where conversion table will be loaded
WINWID          .EQ     $FCA5

EXTVDP          .EQ     $FFE8	; here the values of VDP registers are stored

HOOK            .EQ     $FF43	; used to skip BLOAD operator and call this loader instead
				; H.GONE hook after entering: A=operator code, HL points to it
				
CHRGTR		.EQ	$4666	; subroutine that skips to the next basic token

TXTTAB          .EQ     $F676   ; Starting address of BASIC text area
VARTAB          .EQ     $F6C2   ; Pointer to start of variable space


;INITIALIZE
;__________


INITIALIZE:         
                LD      A,$C3		; Z80 code for "CALL" command
                LD      (HOOK),A
                LD      HL,BLOAD
                LD      (HOOK+1),HL	; set the hook handler
		LD      HL,GREETING_TEXT
		CALL    PUTSTR
		LD      A,23
		LD      BC,$1C98	; print $1C chars with code 23 (this draws a line) 
DRAW_LINE_LOOP:	OUT     (C),A		; by putting them in VDP port $98
		DJNZ    DRAW_LINE_LOOP
		JR      FIRST_TIME                          
                
BLOAD:					; entry for hooked call from patched BLOAD command in BASIC
		CP	$CF		; is it BLOAD we are trying to interpret ?
		RET	NZ		; let BASIC go

SKIP_BLOAD_LOOP:

		CALL	CHRGTR		; skip BLOAD until the end of statement
		JR	NZ,SKIP_BLOAD_LOOP ; skip until the end of statement
		CP	$3A
		JR	Z,AFTER_BLOAD 

; end of line reached - skip until the first statement on the next line
SKIP_UNTIL_NEXT_LINE:
		CALL	CHRGTR
		JR	NZ,SKIP_UNTIL_NEXT_LINE	

AFTER_BLOAD:
		CALL	CHRGTR		; now we point after BLOAD statement
		
		PUSH	AF
		XOR     A
		LD      (RESTART),A 	; BLOAD one file only and return
		POP	AF
		CALL	FIRST_TIME
		JR	BLOAD

FIRST_TIME:

		PUSH	AF
                PUSH    BC
                PUSH    DE
                PUSH    HL
                CALL    CAS
                POP     HL
                POP     DE
                POP     BC
		POP	AF
                RET

; TSR
;______


CAS:     
            
                
; STORE RAM CONFIGURATION
;________________________


                IN      A,($A8)
                LD      (PORT_A8),A
                LD      A,($FFFF)
                CPL
                LD      (RAM_FFFF),A

; SEARCH RAM
;___________

; IN:(H)=PAGE*$40
                
                LD      H,$40

BRAM:           LD      IX,aaTEMP
                LD      (IX+0),0
PLOOP:
                LD      A,(IX+0)
                PUSH    HL
                CALL    $24
                POP     HL
                LD      A,(HL)
                CPL
                LD      (HL),A
                LD      B,(HL)
                INC     (IX+0)
                CP      B
                JR      NZ,PLOOP

; STORE RAM CONFIGURATION FOR ROM
;________________________________


                IN      A,($A8)
                LD      (PORT_A8_4ROM),A
                LD      A,($FFFF)
                CPL
                LD      (RAM_FFFF_4ROM),A
                
		CALL	SWITCH_MEM_BACK

; OPTIONS
;________

                LD      HL,WW
                LD      (HL),0

                                
                LD      BC,0

OPCBC1:         IN      A,($AA)
                AND     $F0
                OR      6
                OUT     ($AA),A

                IN      A,($A9)		; read the state of pressed keys in KB line 6
                
                CP      11111110B       ;SHIFT	- change the display refresh rate
                JR      NZ,NO_REFR

; THIS CHANGES THE REFRESH RATE ON MSX2 AND ABOVE (50/60Hz)
;__________________________________________________________


F_REFR:         LD      A,(EXTVDP+1)	; get the value of VDP register No.1
                XOR     00000010B	; change the frequency setting (50 <-> 60)
                LD      (EXTVDP+1),A	; and put it back
                OUT     ($99),A	
                LD      A,128+9
                OUT     ($99),A
NO_REFR:                          
                LD      (HL),8
                CP      10111111B       ;F2	- use WINWID=8
                JR      Z,REINITIALIZE
                
                LD      (HL),6
                CP      01111111B       ;F3	- use WINWID=6
                JR      Z,REINITIALIZE
                
                LD      (HL),12
                CP      11111101B       ;CTRL	- use WINWID=12
                JR      Z,REINITIALIZE
                
                LD      (HL),0
                CP      11011111B       ;F1	- use WINWID=0 (autodetect it)
                JR      Z,REINITIALIZE

                IN      A,($AA)
                AND     $F0
                OR      7
                OUT     ($AA),A
                IN      A,($A9)		; read the state of pressed keys in KB line 7		
                
                CP      11101111B       ;STOP
                JP      Z,ERROR1                
                
                IN      A,($A2)         ;WAIT UNTIL HEADER SOUND, THEN INITIATE AUTOSYNC.
                XOR     B
                JP      P,OPCBC1
                LD      A,B
                CPL     
                LD      B,A
                INC     C
                LD      A,C
                CP      $20
                JP      NZ,OPCBC1    


REINITIALIZE:   LD      HL,LOADING_MSG              ;Loading
                CALL    PUTSTR

                IN      A,($A8)
                LD      (PORT_A8),A
                LD      A,($FFFF)
                CPL
                LD      (RAM_FFFF),A

; switch mem for (possible) ROM loading

		LD      A,(PORT_A8_4ROM)
                OUT     ($A8),A
                LD      A,(RAM_FFFF_4ROM)
                LD 	($FFFF),A
NOT_ROM_TYPE:


                CALL    E1
                JP      NC,ERROR1
                                
                LD      A,(WW)
                OR      A
                JR      Z,INIBC0
                LD      (WINWID),A
                
INIBC0:         CALL    K7              ;EXPECTS THAT THE DATA BEGINS NOW
                INC	A		;$FF - SIGNAL ERROR
                JR      Z,INIBC0

INIBC1:         CALL    K7
                CP      $D0
                JR      Z,INIBC1


; READ AND SHOW FILE NAME
;________________________

                
                OUT     ($98),A
                LD      B,11
                
LOAD_NAME_LOOP: CALL    K7
                OUT     ($98),A
                DJNZ    LOAD_NAME_LOOP
 

; LOAD THE CONVERSION TABLE
;__________________________
;
; 256 BYTES

                LD      B,0
                LD      HL,CONV_TABLE

LOAD_CONV_TABLE_LOOP:

		CALL    K7
                LD      (HL),A
                INC     HL
                DJNZ    LOAD_CONV_TABLE_LOOP

; CHECK FILE TYPE
;________________

                
                CALL    K7
                LD      (FILE_TYPE),A
                INC	A			; CP $FF
                JP      NZ,NOT_BASIC_TYPE
 
YES_BASIC:      LD      HL,(TXTTAB)
                LD      (DATA_BEGIN),HL
                JR      CDBC_BAS


; BINARY FILE 
;_____________


; DIRECT LOADING OF BIN FILE INTO MEMORY
;_______________________________________

NOT_BASIC_TYPE:
		LD      HL,DATA_BEGIN
                LD      B,6
BIN_HEADER_LOOP:
		CALL    K7
                LD      (HL),A
                INC     HL
                DJNZ    BIN_HEADER_LOOP

; LOAD DATA
;____________
             
CDBC_BAS:       LD      BC,(DATA_BEGIN)
                                                
LOAD_DATA_LOOP:
		CALL    K7_COD
                JR      C,LOAD_DATA_FINISHED
                LD      (BC),A
                INC     BC
                JR      LOAD_DATA_LOOP

LOAD_DATA_FINISHED:			;LOADING ERROR ?

                CP      11
                JP      NC,ERROR1

                LD      (DATA_END),BC

                LD      BC,$0598	;NO ERROR
                LD      HL,OK
                OTIR
               
                CALL    $E7
                
; DECODE DATA
;____________
                
                                
                LD      BC,(DATA_BEGIN)
                LD      HL,(DATA_END)
                
                XOR     A		; erase C flag
                SBC     HL,BC		; calculate the length of data
                
; DECODING
;_________

;THE TABLE SHOULD BE PLACED AT ADDRESS DIVISIBLE BY &H100 
;BC = DATA BEGINNING ADDRESS, HL = LENGTH

DECODER:        LD      DE,CONV_TABLE
                LD      A,(BC)
                ADD     A,E
                LD      E,A
                LD      A,(DE)
                LD      (BC),A
                INC     BC
                DEC     HL
                LD      A,H
                CP      $FF
                JR      NZ,DECODER
 
; The file is loaded and decoded. 
; EXECUTING
;__________
                
                LD      A,(FILE_TYPE)
                CP      $41
                JR	Z,DONT_SWITCH_MEM_BACK
                
		CALL	SWITCH_MEM_BACK
		
DONT_SWITCH_MEM_BACK:

                LD      A,(FILE_TYPE)
                CP      $FF
                JP      Z,YES_BASIC2
                
                LD      HL,(DATA_EXEC)
                      
                LD      A,H                     ; EXECUTABLE?
                OR      A
                JR      Z,DONT_EXECUTE
                
                LD      (CALL_HL+1),HL

CALL_HL:        .DB      $CD,0,0
                
		LD      A,(FILE_TYPE)
		CP	$41			; back from ROM
		JR	NZ,DONT_SWITCH_MEM_AFTER_EXEC

 	  	CALL 	SWITCH_MEM_BACK         ; if we returned from ROM - let's switch memory back now

DONT_SWITCH_MEM_AFTER_EXEC: 	  	

DONT_EXECUTE:   
                LD      A,(RESTART)
                OR      A
                JP      NZ,REINITIALIZE
                RET

YES_BASIC2:     LD      HL,(DATA_END)
                INC     HL
                LD      (VARTAB),HL
                JP      $73AC
                
; SWITCH MEMORY BACK
;____________________

SWITCH_MEM_BACK:

		LD      A,(PORT_A8)              ;INITIAL RAM CONFIGURATION
                OUT     ($A8),A
                LD      A,(RAM_FFFF)
                LD 	($FFFF),A
		RET

; READ 1 BYTE FROM CASSETTE
;__________________________

; RET: (A)
;
; FOR READING THE CONVERSION TABLE


K7:             EXX
                CALL    F_BIOS          ;D=VALUE
                                        ;L=NUMBER OF BITS
                                     
K7RETARDO:      ;IN      A,($A2)         ;ESPERA A QUE TERMINE SIGNAL ERROR
                ;RLCA    
                ;JR      C,K7RETARDO
                
           
                LD      A,D
                EXX
                RET




; READ 1 ENCODED BYTE FROM CASSETTE
;__________________________________

; RET: (A)
;
; FOR THE REST OF DATA


K7_COD:         EXX
                CALL    F_BIOS          ;D=VALUE
                                        ;L=NUMBER OF BITS
                                        
                LD      A,L
                CP      9
                JP      NC,STOP
                
                                     
K7CRETARDO:     ;IN      A,($A2)         ;ESPERA A QUE TERMINE SIGNAL ERROR
                ;RLCA    
                ;JR      C,K7CRETARDO
                
                LD      H,0
                LD      BC,PREDEFINED
                ADD     HL,BC
                LD      A,(HL)
                ADD     A,D
                EXX
                RET

STOP:           EXX

                SCF
                RET                


; SYNCHRONIZATION
;________________


E1:             LD      A,$08
                OUT     ($AB),A
                DI      
                LD      A,$0E
                OUT     ($A0),A
  
                LD      E,$00
                                     
BEGINNING:      LD      B,$F0           ;THIS WAITS FOR CHANGE IN THE PORT

M1B25:          
                IN      A,($A2)
                XOR     E
                JP      P,M1B25
                LD      A,E
                CPL     
                LD      E,A
                DJNZ    M1B25
                

                LD      B,80            ;CYCLES
                LD      C,0
M1B09:          IN      A,($A2)
                XOR     E
                JP      P,M1B17
                LD      A,E
                CPL     
                LD      E,A
                INC     C
                DJNZ    M1B09
                
                JP      MCONT_FIN     

M1B17:          NOP                      
                NOP     
                NOP     
                NOP     
                DJNZ    M1B09
      
MCONT_FIN:      LD      B,0             ;WINWIND=240\C
                LD      A,240
                
WWBC:           SBC     A,C
                JR      C,WWFIN
                INC     B
                JR      WWBC

WWFIN:          LD      A,B
                LD      (WINWID),A
                RET
                
                
; LOADING FROM CASSETTE FUNCION
;_________________________________


;* LINEAS MODIFICADAS           


F_BIOS:                                 ;LD      A,(LOWLIM)
                                        ;LD      D,A
J1AC0:                                  ;CALL    $046F
                                        ;RET     C

                
                
                
                IN      A,($A2)
                RLCA    
                JR      NC,J1AC0

J1AC9:                                  ;CALL    $046F
                                        ;RET     C
                IN      A,($A2)
                RLCA    
                JR      C,J1AC9
                
                LD      E,$00
J1B25:                                  ;INC     C
                                        ;JR      Z,J1B32
                IN      A,($A2)
                XOR     E
                JP      P,J1B25
                LD      A,E
                CPL     
                LD      E,A
                
                LD      D,0             ;LINEA AADIDA
                LD      L,0
                
J1AE6:          

; Contador FSK
; PORT.A2         I AY-3-8910 PSG       data reading


J1B03:          LD      A,(WINWID)
                LD      B,A
                LD      C,0
J1B09:          IN      A,($A2)
                XOR     E
                JP      P,J1B17
                LD      A,E
                CPL     
                LD      E,A
                INC     C
                DJNZ    J1B09
                JP      CONT_FIN     

;__________________________________________

J1B17:          NOP                      
                NOP     
                NOP     
                NOP     
                DJNZ    J1B09
CONT_FIN:       LD      A,C

;__________________________________________

                CP      $04             ;BIT=1?
                                        ;CCF     
                RET     NC              ;RET    C       ERROR IF A>4 => END OF DATA

                CP      $02             ;BIT=0?
                CCF     
                RL      D               ;RR D
                                        ;LD      A,C
                                        
                LD      A,C
                RRCA                    ;IS ODD (UNEVEN)?
                
                JR      C,L1B25         ;ODD
                
K1B25:          IN      A,($A2)
                XOR     E
                JP      P,K1B25
                LD      A,E
                CPL     
                LD      E,A
                
L1B25:          IN      A,($A2)
                XOR     E
                JP      P,L1B25
                LD      A,E
                CPL     
                LD      E,A                
                
                
                INC     L               ;*DEC L
                JP      NZ,J1AE6
                
                
                                        ;CALL    $046F           ;NO DEBERIA LLEGAR AQUI
                LD      A,D
                RET
                
; ERRORS
;________

ERROR1:         LD      BC,$0698
                LD      HL,ERR1
                OTIR
                
                CALL    $E7
                
		CALL 	SWITCH_MEM_BACK                
                LD      A,$C9		; Z80 code for "RET" command
                LD      (HOOK),A

                RET

; PRINT STRING
;______________

PUTSTR:         LD      A,(HL)          
                CP      36             
                RET     Z
                CALL    $A2		; CALL CHPUT           
                INC     HL
                JR      PUTSTR

                

;CHKSUM:
;	ld de,(DATA_BEGIN)
;	ld hl,(DATA_END)
;	xor a
;	sbc hl,de
;	ld b,h
;	ld c,l
;	ld h,0
;	ld l,h
;CHKSLOOP: push bc
;	ld a,(de)
;	ld c,a
;	ld b,0
;	inc de
;	add hl,bc
;	pop bc
;	dec bc
;	ld a,b
;	or c
;	jr nz,CHKSLOOP
;	ld a,l
;	ld ($E600),a
;	ld a,h
;	ld ($E601),a
;	ret

;TABLES
;______

                
PREDEFINED:     .DB      0,0,2,6,14,30,62,126,254

PORT_A8:	.DB      0
RAM_FFFF:	.DB      0
PORT_A8_4ROM:   .DB      0
RAM_FFFF_4ROM:  .DB      0

aaTEMP:         .DB      0

GREETING_TEXT:  .DB      $D,$A
		.AS      "MicroWAVer (c) 2005 WYZ & Cax"
                .DB      $D,$A,1,87,"$"

LOADING_MSG:    .DB      $D,$A,"Loading:$"

ERR1:           .AS      " <Err>"
OK:             .AS      " <OK>"

DATA_BEGIN:     .DW      0
DATA_END:       .DW      0
DATA_EXEC:      .DW      0
FILE_TYPE:      .DB      0
RESTART:        .DB      1

FINISH:
WW:             .DB      0
