// (BUG ?) in normal (non-packed BLOAD) mode last file should stop without waiting for next audio track
// Also need a way to encode megaroms via 2205 BLOAD mode (special loader with bload"cas:",r ?)

// 1) now "-cd -xp" at 5512 is the same as nocd's "-c" at 3675 - how it can be ?
//    How to make it clear in the interface and in the command line ?
//    It should be like "mwaver game.rom" or "mwaver 5512 game.rom"
//
// 2) patch all konami + "magic kid wiz" rom (and all other known with protection)
// 3) finish documentation file
// 4) make a .ptc file with trainers for most known games (use ExecROM's XPC or other)
// 5) if in dos mode if .com is bigger than X, it's always splitted and even not tried to be packed
// 6) add .cas encoding
// 7) why MW stops (motor off) after loading loader and waits for F1/F2/F3/CTRL/STOP ?
// 8) add option to change a 6-char name to a specified one
// 9) add checksum checking and <ERR> if bad (to k7.com too !). Test it with mp3 96kbps.
//10) test what happens if we want non-executing ROM (don't execute JP (HL) ?) and BAS
//11) "-cd" should be default. Use "-nocd" for free frequency mode
//12) use SELECT button instead of SHIFT for 50/60Hz switch

/*
Catapult:

1) browse for place to put WAV (browse for folder and leave the name unchanged ?)
2) Make MP3 from menu (128kbps for 3675, 192kbps for 5512, ???kbps for 2205; don't make for no-cd mode

*/

/*
Spreading:

//1) update site(s) narod.ru, nm.ru
//2) make WAVs downloadable ?
//3) announce on MRC, comp.sys.msx newsgroup and other boards

*/


/*---------------------------------------------------------

New in 0.91:

1) fixed memory switch problem during loading (some BIN games didn't work)
2) in CD-XP mode: default BLOAD-format bps rate changed from 2205 to 3150 (so loader is 2s shorter now)
3) square waveform is used by default. In 3675 compressed mode you can use -sine
4) fixed bug in bit-packing algorithm (wrong char-frequency counting)
5) fixed bug in bit-packing-rate calculation
6) fixed bug: now char frequency/conversion table is built BEFORE packing of ROM,BAS,COM (BIN was OK)
7) renamed "MicroWAVer Catapult" to "MicroWAVeRunner"
8) name of first file in the list is used (6 chars) as "Found:" filename (instead of "LOADER")
9) made icon for the MicroWAVeRunner
10) added drag-n-drop of input files into list
11) fixed BUG: BLOAD patching killed BASIC programs - now BASIC is not patched

-----------------------------------------------------------*/


//==================================================================================
//  File.......: microwaver.c
//  Copyright..: Original idea & VB coding, WAV format & ASM loaders - WYZ (jvicentemz@yahoo.es)
//               VB to C translation and everything else - Cax (borus@bigfoot.com)
//  Version....: 0.91
//  Description: Utility for encoding files to be loaded into MSX via tape interface
//==================================================================================

#include <stdio.h>

#include "k7ldr.h"
#include "ppibm.h"
#include "unpack.h"
#include "unpk_com.h"
#include "ram-dos.h"

#define MIN_FILE_LENGTH     8
#define MAX_ROM_FILE_LENGTH 48*1024
#define DOS_SPLIT_SIZE      45*1024
#define FILENAME_LEN        1024

#define TRUE  1
#define FALSE 0

// input for space()
#define DEFINED_PAUSE -1
#define SHORT_PAUSE   -2
#define UNPACK_KB_PER_SEC 22

// low/high values for 8-bit WAV
#define b0  0x7F
#define b1  0xFF

// low/high values for 16-bit WAV
#define bb0 0x0

#define bb0a 0xD555
#define bb0b 0xAAAA
#define bb0c 0x8000

#define bb1 0x7FFF

#define bb1a 0x2AAA
#define bb1b 0x5555
#define bb1c 0x7FFF


#define bb1_0 0x0
#define bb1_1 0x2BC6
#define bb1_2 0x5246
#define bb1_3 0x6ED9
#define bb1_4 0x7E0D

#define bb0_0 0x0
#define bb0_1 0xD43A
#define bb0_2 0xADBA
#define bb0_3 0x9127
#define bb0_4 0x81F3

// Full sine table:
// 0x0000 0x1630 0x2BC6 0x3FFF 0x5246 0x620C 0x6ED9 0x7846 0x7E0D 0x7FFE
// 0x0000 0xE9C7 0xD43A 0xC001 0xADBA 0x9DF4 0x9127 0x87BA 0x81F3 0x8002

// ------------------------------------------------------------------------
// Waveforms: square and sine-alike, each uses it's own number of samples
//
// TODO: not all of them are used. Maybe some additional parameters should
// be added to the program to enable choosing between waveforms
// ------------------------------------------------------------------------

#define WAVEFORM_BYTE_6   6
#define WAVEFORM_BYTE_8   8

#define WAVEFORM_SHORT_8  108	// results in 44100/8  = 5512 bps
#define WAVEFORM_SHORT_12 112   // results in 44100/12 = 3675 bps
#define WAVEFORM_SHORT_14 114   // results in 44100/14 = 3150 bps
#define WAVEFORM_SHORT_18 118   // results in 44100/18 = 2450 bps
#define WAVEFORM_SHORT_20 120   // results in 44100/20 = 2205 bps

#define WAVEFORM_SHORT_12_SINE 212   // results in 44100/12 = 3675 bps
#define WAVEFORM_SHORT_14_SINE 214   // results in 44100/14 = 3150 bps
#define WAVEFORM_SHORT_20_SINE 220   // results in 44100/14 = 3150 bps

// files types
#define TYPE_BASIC  0xFF
#define TYPE_BINARY 0xFE
#define TYPE_ROM    0x41
#define TYPE_COM    0x00
#define TYPE_DOS    0x01

char* outputFileName = "out.wav";
char* fileNamePointer[100];
char fileExecAttrib[100];
unsigned char *inputMemPointer;
FILE *inputFileHandle, *outputFileHandle;
size_t inputFileLength, bytesRead, bytesWritten, inputFileOffset;

char casFileName[13];
int  casFileNameLen;

int cells[256][4];
int compressedMode = FALSE;
int experimentalMode = FALSE;
int cdMode = FALSE;
int packMode = TRUE;
int fixMode = TRUE;
int ldrMode = TRUE;
int dosMode = FALSE;
int sineMode = FALSE;
int filesNumber = 0;
int baudRate;
int spaceTimeMs = 1000;

unsigned char WAVEFORM_SHORT_BLOAD;

unsigned int power2[10] = {1,2,4,8,16,32,64,128,256,512};

char errorList[][80] = {
   "1st argument (%s) is not -cd\nor invalid baud rate: should be > 0, < 6000",	// 1
   "Command line is incomplete",												// 2
   "Unrecognized command line option (%s)",										// 3
   "Filename(s) to be encoded are not specified",		 						// 4
   "Failed to create output file '%s'", 		 								// 5
   "Command line option (%s) is not expected here",								// 6
   "Options -c and -xp can't be used together",									// 7
   "Attaching loader supported in CD mode only",								// 8
   "Failed to read input file %s", 												// 9
   "Input file size is incorrect (%s)",	 										// 10
   "Can't allocate enough memory to load file %s",								// 11
   "Failed to write to output file %s",		 		 							// 12
   "Failed to fseek in output file %s",		 		 							// 13
   "STOPPED: Unsupported type of file in this encoding mode",					// 14
   "Invalid number of VRAM pages for ramdisk (%s): should be >=0, <=7",			// 15
   "Invalid number of RAM  pages for ramdisk (%s): should be >=1, <=3 (8 max)", // 16
   };

const char* patchFileName = "mwaver.ptc";

const char romsInfo[][100] = {
	"d5b97504|Twin Bee (Konami)        |4028:22,00,00;40FB:21,00,00",
	"2546dc60|King's Valley (Konami)   |4040:80;409F:83",
	"8276c17c|King's Valley (Konami)   |4040:80;409F:83",
	"37dc33f9|Knight Mare (Konami)     |4028:22,00,00;4055:22,00,00;40CB:21,00,00",
	"740545f8|Yie Ar Kung-Fu 2 (Konami)|4028:22,00,00;4056:22,00,00;40C3:21,00,00",
	"5dc529b7|Pippols (Konami)         |4033:22,00,00;4076:21,00,00",

	"\0"
};

// ----- write the packed version of converted file -----
void writePackedVersion(char* fileName, char* ext)
{
	char binName[FILENAME_LEN];
	FILE *outHandle;
	strcpy(binName, fileName);
	strcat(binName, ext);
	outHandle = fopen(binName, "wb");
	fwrite(inputMemPointer, 1, inputFileLength, outHandle);
	fclose(outHandle);
	printf("Created packed %s version: %s\n", ext, binName);
	if (stricmp(ext, ".bin") == 0)
	{
	  printf("from address: %x, to address: %x, exec address: %x\n",
		inputMemPointer[1] + inputMemPointer[2]*256,
		inputMemPointer[3] + inputMemPointer[4]*256,
		inputMemPointer[5] + inputMemPointer[6]*256);
	}
}

void putShortIntoBuffer(unsigned char* buf, unsigned short value)
{
		buf[0] = value % 0x100;
		buf[1] = value / 0x100;
}
// ----- read the value of 2 hex bytes from a string -----
unsigned char str2byte(const char* p)
{
	unsigned char n;
	if (p[0] >= '0' && p[0] <= '9') n = p[0] - '0';
	if (p[0] >= 'a' && p[0] <= 'f') n = p[0] - 'a' + 10;
	if (p[0] >= 'A' && p[0] <= 'F') n = p[0] - 'A' + 10;
	n = 16 * n;
	if (p[1] >= '0' && p[1] <= '9') n += (p[1] - '0');
	if (p[1] >= 'a' && p[1] <= 'f') n += (p[1] - 'a' + 10);
	if (p[1] >= 'A' && p[1] <= 'F') n += (p[1] - 'A' + 10);
	return n;
}

// patches the buffer using given description (patchline)
void patchUsingPatchline(char* patchLine, unsigned char* buf)
{
	unsigned char byte;
	unsigned short address;
	int j;
	char name[100];

	// show the name of the ROM and patch it
	for (j=9; patchLine[j] != '|'; j++)			{name[j-9] = patchLine[j];}
	name[j-9]='\0';
	printf("Detected ROM: %s\n", name);

	j++;
	// parse the following format:
	// 4fee:01,22,EE;
	while (j < strlen(patchLine))
	{
		address = str2byte(patchLine+j) * 0x100 + str2byte(patchLine+j+2);
		printf("%04x:", address);
		j+=5;
		do
		{
			byte = str2byte(patchLine+j);
			j+=3;
			printf("%02x(%02x) ", byte, buf[address - 0x4000]);
			buf[address - 0x4000] = byte;
			address++;
		}
		while(patchLine[j-1] == ',');
		printf("\n");
	}
}

// ----- Identify and patch the ROM using the checksum table -----
void patchROM(unsigned char* buf)
{
	// compute the checksum to identify the ROM
	unsigned int checkSum = 0, i, patchFound;
	char s[9], patchLine[100];
	FILE* patchFile;

	for (i=0; i < 8192; i+=4) // checksum of the first 8K
	{
		checkSum += buf[i]+0x100*buf[i+1]+0x10000*buf[i+2]+0x1000000*buf[i+3];
	}
	sprintf(s, "%08x", checkSum);

	// try to use external patch file "mwaver.ptc"
	printf("\n");
	if ((patchFile = fopen(patchFileName, "r")))
	{
		int l;

		patchFound = FALSE;
		printf("Looking for checksum %s in %s... ", s, patchFileName);

		while (fgets(patchLine, 100, patchFile) != NULL)
		{
			// set the checksum to 00000000 and you can patch anything
			if (strncmp(s, patchLine, 8) == 0 || strncmp("00000000", patchLine, 8) == 0)
			{
				patchFound = TRUE;
				printf("found !\n");
				l = strlen(patchLine)-1;
				if (patchLine[l] == '\r' || patchLine[l] == '\n') patchLine[l--] = '\0';
				if (patchLine[l] == '\r' || patchLine[l] == '\n') patchLine[l] = '\0';
				patchUsingPatchline(patchLine, buf);
			}
		}
		fclose(patchFile);
		if (!patchFound)		{printf("not found.\n");}
	}

	patchFound = FALSE;
	printf("Looking for checksum %s in internal database... ", s);

	for (i=0; romsInfo[i][0] != '\0'; i++)
	{
		if (strncmp(s, romsInfo[i], 8) == 0)
		{
			patchFound = TRUE;
			printf("found !\n");
			strcpy(patchLine, romsInfo[i]);
			patchUsingPatchline(patchLine, buf);
		}
	}
	if (!patchFound)		{printf("not found.\n");}
}

// ----- Determine the 8+3 filename to be stored in WAV -----
void setCasFileName(char* fileName)
{
	int offset1, offset2, i;
	char dosFileName[12] = "           \0";

	casFileNameLen = 0;
	for (offset1=strlen(fileName)-1; offset1 >= 0; offset1--)
	{
		if (*(fileName + offset1) == '.')  break;
		if (*(fileName + offset1) == '/')  break;
		if (*(fileName + offset1) == '\\') break;
	}

	offset1--;
	if (offset1 <= 0 || *(fileName + offset1 + 1) != '.')
	{
		offset1 = strlen(fileName);
	}

	for (offset2=offset1; offset2 >= 0; offset2--)
	{
		if (*(fileName + offset2) == '/' || *(fileName + offset2) == '\\') break;
	}
	offset2++;

	for (i=0; i < 8; i++)
	{
		if (offset2 + i <= offset1)
		{
			casFileName[casFileNameLen++] = *(fileName + offset2 + i);
		}
	}

	if (offset1 != strlen(fileName))
	{
		for (i=1; i <= 4; i++)
		{
			if (offset1 + i < strlen(fileName))
			{
				casFileName[casFileNameLen++] = *(fileName + offset1 + i);
			}
		}
	}
	casFileName[casFileNameLen] = '\0';

	if (dosMode)
	{
		offset1 = 0;
		for (i=0; i < strlen(casFileName); i++)
		{
			if (casFileName[i] == '.')
			{
				offset1 = 8;
			}
			else
			{
				dosFileName[offset1++] = casFileName[i];
			}
		}

		strcpy(casFileName, dosFileName);
		casFileNameLen = 11;
	}
}

// ----- Clean up memory and close files -----
void cleanUp()
{
   if (inputMemPointer)		free(inputMemPointer);
   if (inputFileHandle)		fclose(inputFileHandle);
   if (outputFileHandle)	fclose(outputFileHandle);
}

// ----- Exit with given error number & message -----
void exitOnErrorText(int errorNum, char* text)
{
   cleanUp();

   if (outputFileHandle)
   {
	   unlink(outputFileName);
   }

   printf("\nERROR: ");
   printf(errorList[errorNum-1], text);
   printf("\n");
   exit(errorNum);
}

// ----- Exit with given error number -----
void exitOnError(int errorNum)
{
	exitOnErrorText(errorNum, "");
}

// ----- Return the current size of output file -----
size_t lengthOfOutputFile()
{
	if (fseek(outputFileHandle, 0, SEEK_END))		{exitOnErrorText(13, outputFileName);}
	return (size_t)ftell(outputFileHandle);
}

// ----- Write 1 byte to the output file -----
void putByte(unsigned char b)
{
	   bytesWritten = fwrite(&b, sizeof(b), sizeof(b), outputFileHandle);
	   if (bytesWritten != sizeof(b))				{exitOnErrorText(12, outputFileName);}
}

// ----- Write array of bytes to the output file -----
void putByteArray(int arraySize, unsigned char * byteArray)
{
	int i;
	for(i=0; i<arraySize; i++)	{putByte(byteArray[i]);}
}

// ----- Write 2 bytes (short) to the output file -----
void putShort(unsigned short s)
{
	putByte(s % 256);
	putByte(s / 256);
}

// ----- Write array of byte pairs (shorts) to the output file -----
void putShortArray(int arraySize, unsigned short * shortArray)
{
	int i;
	for(i=0; i<arraySize; i++)	{putShort(shortArray[i]);}
}

// ----- Set the reading of the input file to the beginning -----
void rewindInputFile()
{
	inputFileOffset = 0;
}

// ----- Open the input file -----
void openInputFile(char* fileName)
{
   int i;
   if (strcmp(fileName, "LOADER") == 0)
   {
		inputFileLength = sizeof(internalLoader);

	    inputMemPointer = (unsigned char*) malloc(inputFileLength);
	    if (!inputMemPointer)				{exitOnErrorText(11, fileName);}

		for (i=0; i < inputFileLength; i++)
		{
			inputMemPointer[i] = internalLoader[i];
		}

   		rewindInputFile();
   		return;
   }

   if (strncmp(fileName, "RAMDOS", 6) == 0)
   {
		inputFileLength = sizeof(ram_dos);

	    inputMemPointer = (unsigned char*) malloc(inputFileLength);
	    if (!inputMemPointer)				{exitOnErrorText(11, fileName);}

		for (i=0; i < inputFileLength; i++)
		{
			inputMemPointer[i] = ram_dos[i];
		}

		if (strlen(fileName) > 7)
		{
			i = fileName[7] - '0';
			if (i < 0 || i > 7) { exitOnErrorText(15, fileName); }
			inputMemPointer[7] = i;
		}

		if (strlen(fileName) > 8)
		{
			i = fileName[8] - '0';
			if (i < 1 || i > 8) { exitOnErrorText(16, fileName); }
			inputMemPointer[8] = i;
		}

		if (strlen(fileName) > 9 && fileName[9] == 'n')	{inputMemPointer[9] = 0;}

   		rewindInputFile();
   		return;
   }

   // Open, check size, allocate memory and read input file
   inputFileHandle = fopen(fileName, "rb");
   if (!inputFileHandle)					{exitOnErrorText(9, fileName);}

   if (fseek(inputFileHandle, 0, SEEK_END))	{exitOnErrorText(9, fileName);}

   inputFileLength = (size_t)ftell(inputFileHandle);
   if (fseek(inputFileHandle, 0, SEEK_SET))	{exitOnErrorText(9, fileName);}

   // allocate 1K more to be sure that packing already packed file will fit the allocated buffer
   inputMemPointer = (unsigned char*) malloc(inputFileLength+1024);
   if (!inputMemPointer)					{exitOnErrorText(11, fileName);}

   bytesRead = fread(inputMemPointer, sizeof(unsigned char), inputFileLength, inputFileHandle);
   if (bytesRead != inputFileLength)		{exitOnErrorText(9, fileName);}

   rewindInputFile();

   if (inputFileLength < (size_t)MIN_FILE_LENGTH ||
   	   (inputFileLength > (size_t)MAX_ROM_FILE_LENGTH) && inputMemPointer[0] == TYPE_ROM && (!dosMode))
   											{exitOnErrorText(10, fileName);}

}

// ----- Close the input file -----
void closeInputFile()
{
   if (inputMemPointer)		free(inputMemPointer);
   if (inputFileHandle)		fclose(inputFileHandle);
}

// ----- EOF of input file -----
int endOfInputFile()
{
	return (inputFileOffset >= inputFileLength);
}

// ----- get next 1 byte from input file -----
unsigned char getByte()
{
	if (! endOfInputFile())
	{
		return (unsigned char)inputMemPointer[inputFileOffset++];
	}
}

/* ------------------------------------------------------------------------ */
/*		pack the buffer
/* ------------------------------------------------------------------------ */

int pack2BIN(unsigned char* buf, int bufSize, unsigned char fileType)
{
    char *tmpName, ppName[FILENAME_LEN], ppCmdLine[FILENAME_LEN];
	FILE *outHandle, *inHandle;
	size_t packedSize;
	// 21 00 01		ld   hl,$100
	// E5			push hl
	// 11 xx xx		ld   de, unpackCodeAddress + sizeof(UNPACK_COM_CODE)
	// 01 xx xx		ld   bc, packedSize + sizeof(UNPACK_COM_CODE) + reservedBytes
	// 09			add  hl,bc
	// ED B8		lddr
	// D1			pop  de
	// 21 xx xx		ld   hl, unpackCodeAddress - packedSize
	// 01 xx xx		ld   bc, (if can't pack - size of file, otherwise - 0)
	// C3 xx xx		jp   unpackCodeAddress
	unsigned char comBeginningCode[] = {0x21, 0x00, 0x01, 0xE5, 0x11,0,0, 0x01,0,0, 0x9, 0xED, 0xB8, 0xD1, 0x21,0,0, 0x01,0,0, 0xC3,0,0};
	int reservedBytes = (fileType == TYPE_DOS) ? sizeof(comBeginningCode) : 7;

	unsigned short unpackAddress, fromAddress, endAddress, packedDataAddress, unpackCodeStart, unpackCodeAddress;

	// store the PROPACK packer exe in temp dir
   	tmpName = tempnam(NULL, NULL);
	strcpy(ppName, tmpName);
	free(tmpName);
	strcat(ppName, ".exe");

    if (!(outHandle = fopen(ppName, "wb")))		{exitOnErrorText(5, ppName);}
	if (sizeof(PROPACK_EXE) != fwrite(PROPACK_EXE, 1, sizeof(PROPACK_EXE), outHandle))
	{exitOnErrorText(12, ppName);}
	fclose(outHandle);

	// store the file to be packed in temp dir
	tmpName = tempnam(NULL, NULL);
    if (!(outHandle = fopen(tmpName, "wb")))		{exitOnErrorText(5, tmpName);}
	if (bufSize != fwrite(buf, 1, bufSize, outHandle))
	{exitOnErrorText(12, tmpName);}
	fclose(outHandle);

	// execute the packer
	strcpy(ppCmdLine, ppName);
	strcat(ppCmdLine, ">nul p -m 2 -l ");
	strcat(ppCmdLine, tmpName);

    system(ppCmdLine);
	unlink(ppName);

	// load the packed file
	if (!(inHandle = fopen(tmpName, "rb")))						{exitOnErrorText(9, tmpName);}
	if (fseek(inHandle, 0, SEEK_END))							{exitOnErrorText(9, tmpName);}
	packedSize = (size_t)ftell(inHandle);
	if (fseek(inHandle, 0, SEEK_SET))							{exitOnErrorText(9, tmpName);}
	if (packedSize != fread(buf + reservedBytes, 1, packedSize, inHandle)) 	{exitOnErrorText(9, tmpName);}
	fclose(inHandle);

	unlink(tmpName);
	free(tmpName);

	if (fileType == TYPE_DOS)
	{
		unpackCodeAddress = 0xBC00;
		putShortIntoBuffer(comBeginningCode+5,  unpackCodeAddress + sizeof(UNPACK_COM_CODE));
		putShortIntoBuffer(comBeginningCode+8,  packedSize + sizeof(UNPACK_COM_CODE) + reservedBytes);
		putShortIntoBuffer(comBeginningCode+15, unpackCodeAddress - packedSize);
		putShortIntoBuffer(comBeginningCode+18, (bufSize == packedSize ? bufSize : 0));
		putShortIntoBuffer(comBeginningCode+21, unpackCodeAddress);

		memcpy(buf, comBeginningCode, sizeof(comBeginningCode));
		memcpy(buf + reservedBytes + packedSize, UNPACK_COM_CODE, sizeof(UNPACK_COM_CODE));
		rewindInputFile();
		return reservedBytes + packedSize + sizeof(UNPACK_COM_CODE);
	}
	else
	{
		unpackCodeAddress = 0xE000;
		// make the BIN to be loaded
		unpackAddress = (fileType == TYPE_COM ? 0x100 : (buf[3] & 0xC0) * 256);

		fromAddress = unpackCodeAddress - packedSize;
		packedDataAddress = fromAddress;
		endAddress = unpackCodeAddress + sizeof(UNPACK_CODE);
		unpackCodeStart = reservedBytes + packedSize;

		buf[0] = 0xFE;
		putShortIntoBuffer(buf+1, fromAddress);
		putShortIntoBuffer(buf+3, endAddress);
		putShortIntoBuffer(buf+5, unpackCodeAddress);

		// attach the unpacking code
		memcpy(buf + reservedBytes + packedSize, UNPACK_CODE, sizeof(UNPACK_CODE));

		// set the input for the unpacker (inside it's code)
		buf[unpackCodeStart+2] = fileType;
		putShortIntoBuffer(buf+unpackCodeStart+3, packedDataAddress);
		putShortIntoBuffer(buf+unpackCodeStart+5, unpackAddress);
		putShortIntoBuffer(buf+unpackCodeStart+7, (bufSize == packedSize ? bufSize : 0));

		rewindInputFile();

		return reservedBytes + packedSize + sizeof(UNPACK_CODE);
	}
}

// -----
void B_INITIAL(unsigned char bits)
{

	switch (bits)
	{
		// note: B_INITIAL is always 6 samples for any waveform type

		case WAVEFORM_BYTE_6:
		case WAVEFORM_BYTE_8: { // 6 or 8
			static unsigned char  b[] = {b0,b0,b0,b0,b1,b1};
			putByteArray(sizeof(b), b); } break;

		case WAVEFORM_SHORT_12_SINE: {
			static unsigned short b[] = {bb0b,bb0c,bb0c,bb0b,bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_12: {
			static unsigned short b[] = {bb0,bb0,bb0,bb0,bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_8: {
			static unsigned short b[] = {bb0,bb0,bb0,bb0,bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;
	}
}

// -----
void B_ZERO(unsigned char bits)
{
	switch (bits)
	{
		case WAVEFORM_BYTE_6:  { static unsigned char b[] = {b0,b0,b0, b1,b1,b1};
			putByteArray(sizeof(b), b); } break;

		case WAVEFORM_BYTE_8:  { static unsigned char b[] = {b0,b0,b0,b0, b1,b1,b1,b1};
			putByteArray(sizeof(b), b); } break;

		case WAVEFORM_SHORT_8: { static unsigned short b[] = {bb0,bb0,bb0,bb0, bb1,bb1,bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_12_SINE: { static unsigned short b[] =
			{bb0a,bb0b,bb0c, bb0c,bb0b,bb0a, bb1a,bb1b,bb1c, bb1c,bb1b,bb1a};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_12: { static unsigned short b[] =
			{bb0,bb0,bb0, bb0,bb0,bb0, bb1,bb1,bb1, bb1,bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_14_SINE: { static unsigned short b[] =
		    {bb0_0,bb0_1,bb0_2,bb0_4, bb0_3,bb0_2,bb0_1,
			 bb1_0,bb1_1,bb1_2,bb1_4, bb1_3,bb1_2,bb1_1};
    		putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_14: { static unsigned short b[] =
		    {bb0,bb0,bb0,bb0,bb0,bb0,bb0, bb1,bb1,bb1,bb1,bb1,bb1,bb1};
    		putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_18: { static unsigned short b[] =
			{bb0_0,bb0_1,bb0_2,bb0_3,bb0_4, bb0_4,bb0_3,bb0_2,bb0_1,
			 bb1_0,bb1_1,bb1_2,bb1_3,bb1_4, bb1_4,bb1_3,bb1_2,bb1_1};
    		putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_20_SINE: { static unsigned short b[] =
			{bb0_0,bb0_1,bb0_2,bb0_3,bb0_4, bb0_4,bb0_3,bb0_2,bb0_1,bb0_0,
			 bb1_0,bb1_1,bb1_2,bb1_3,bb1_4, bb1_4,bb1_3,bb1_2,bb1_1,bb1_0};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_20: { static unsigned short b[] =
			{bb0,bb0,bb0,bb0,bb0, bb0,bb0,bb0,bb0,bb0,
			 bb1,bb1,bb1,bb1,bb1, bb1,bb1,bb1,bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;
	}
}

// -----
void B_ONE(unsigned char bits)
{
	switch (bits)
	{
		case WAVEFORM_BYTE_6:  { static unsigned char b[] =
			{b0,b0,b1,b0,b1,b1};
			putByteArray(sizeof(b), b); } break;

		case WAVEFORM_BYTE_8:  { static unsigned char b[] =
			{b0,b0,b1,b1,b0,b0,b1,b1};
			putByteArray(sizeof(b), b); } break;

		case WAVEFORM_SHORT_8: { static unsigned short b[] =
			{bb0,bb0,bb1,bb1,bb0,bb0,bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_12_SINE: { static unsigned short b[] =
			{bb0b,bb0c,bb0b, bb1b,bb1c,bb1b, bb0b,bb0c,bb0b, bb1b,bb1c,bb1b};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_12: { static unsigned short b[] =
			{bb0,bb0,bb0, bb1,bb1,bb1, bb0,bb0,bb0, bb1,bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_14_SINE: { static unsigned short b[] =
		    {bb0_0,bb0_2,bb0_4,bb0_1, bb1_1,bb1_4,bb1_2,
			 bb0_0,bb0_2,bb0_4,bb0_1, bb1_1,bb1_4,bb1_2};
    		putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_14: { static unsigned short b[] =
		    {bb0,bb0,bb0,bb0, bb1,bb1,bb1,
			 bb0,bb0,bb0,bb0, bb1,bb1,bb1};
    		putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_18: { static unsigned short b[] =
			{bb0_0,bb0_2,bb0_4,bb0_3,bb0_1, bb1_1,bb1_3,bb1_4,bb1_2,
			 bb0_0,bb0_2,bb0_4,bb0_3,bb0_1, bb1_1,bb1_3,bb1_4,bb1_2};
    		putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_20_SINE: { static unsigned short b[] =
			{bb0_0,bb0_2,bb0_4,bb0_3,bb0_1, bb1_1,bb1_2,bb1_3,bb1_4,bb1_2,
			 bb0_0,bb0_2,bb0_4,bb0_3,bb0_1, bb1_1,bb1_2,bb1_3,bb1_4,bb1_2};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_20: { static unsigned short b[] =
			{bb0,bb0,bb0,bb0,bb0, bb1,bb1,bb1,bb1,bb1,
			 bb0,bb0,bb0,bb0,bb0, bb1,bb1,bb1,bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;
	}
}

// -----
void B_ERROR(unsigned char bits)
{
	switch (bits)
	{
		case WAVEFORM_BYTE_6:  { static unsigned char b[] =
			{b0,b1,b0,b1,b0,b1};
			putByteArray(sizeof(b), b); } break;

		case WAVEFORM_BYTE_8:  { static unsigned char b[] =
			{b0,b1,b0,b1,b0,b1,b0,b1};
			putByteArray(sizeof(b), b); } break;

		case WAVEFORM_SHORT_8: { static unsigned short b[] =
			{bb0,bb1,bb0,bb1,bb0,bb1,bb0,bb1};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_12_SINE: { static unsigned short b[] =
			{bb0b,bb0c, bb1b,bb1c, bb0b,bb0c, bb1b,bb1c, bb0b,bb0c, bb1b,bb1c};
			putShortArray(sizeof(b)/2, b); } break;

		case WAVEFORM_SHORT_12: { static unsigned short b[] =
			{bb0,bb0, bb1,bb1, bb0,bb0, bb1,bb1, bb0,bb0, bb1,bb1};
			putShortArray(sizeof(b)/2, b); } break;
	}
}

// ----- write the WAV file header to the output file -----
void header_wav()
{
	unsigned char h_wav[44] = {	0x52, 0x49, 0x46, 0x46, 0xAA, 0x0,  0x0,  0x0,  0x57, 0x41,
								0x56, 0x45, 0x66, 0x6D, 0x74, 0x20, 0x10, 0x0,  0x0,  0x0,
								0x1,   0x0,  0x1,  0x0, 0x44, 0xAC, 0x0,  0x0,  0x44, 0xAC,
								0x0,   0x0,  0x1,  0x0, 0x8,  0x0,  0x64, 0x61, 0x74, 0x61,
								0x0,   0x0,  0x0,  0x0 };
	int i;
    for (i=0; i <= 43; i++)		{putByte(h_wav[i]);}
}

// ----- Insert the given data "aa" at the specified offset "a" in the output file -----
void I_data(size_t a, long aa)
{
	unsigned char b;
	fseek(outputFileHandle, a-1, SEEK_SET);

	do
	{
		b = aa % 0x100;
		bytesWritten = fwrite(&b, sizeof(b), sizeof(b), outputFileHandle);
		if (bytesWritten != sizeof(b))		{exitOnErrorText(13, outputFileName);}
		aa = aa / 0x100;
	}
	while (aa != 0);
}

// ----- Update the header of WAV file with actual values -----
void modifyWavHeader()
{
	I_data(5,  lengthOfOutputFile() - 8);    // WAV length
	I_data(41, lengthOfOutputFile() - 44);   // data length

	if (cdMode)
	{
		// version CD 44100 Hz/16 bits/stereo
		I_data(25, 44100);
		I_data(29, 44100*2);
		I_data(23, 1);
		I_data(33, 2);
		I_data(35, 16);
	}
	else
	{
		I_data(25, baudRate * 8);
		I_data(29, baudRate * 8);
	}
}

// ----- output 1 byte to the output file in non-compressed mode -----
void K7(unsigned char a, unsigned char bits)
{
	int l = 0;
	B_ZERO(bits);

	while (l <= 7)
	{
		if ((a & power2[l]) == 0)
		{
			B_ZERO(bits);
		}
		else
		{
			B_ONE(bits);
		}
		l++;
	}

	B_ONE(bits);
	B_ONE(bits);
}

// ----- output 1 byte to the output file in compressed or experimental mode -----
void K7_c(unsigned char a, unsigned char bits)
{
	int l = 0;
	B_INITIAL(bits);

	while(power2[l] <= a)
	{
		l++;
	}
	l--;

	do
	{
		if ((a & power2[l]) == 0)
		{
			B_ZERO(bits);
		}
		else
		{
			B_ONE(bits);
		}

		l--;

	} while (l >= 0);

	B_ERROR(bits);
}

// ----- create a silence (pause) between files in output WAV file -----
void space(int useTimeMs)
{
	int i;
	float sec;
	if      (useTimeMs == SHORT_PAUSE) 	 {sec = 0.01;}
	else if (useTimeMs == DEFINED_PAUSE) {sec = spaceTimeMs / 1000.0;}
	else                                 {sec = useTimeMs   / 1000.0;}

	if (cdMode)
	{
		for (i=0; i < 44100 * sec; i++)	{putShort(bb0);}
	}
	else
	{
		for (i=0; i < baudRate * sec * 10; i++)	{putByte(b0);}
	}
}

// ----- Encode file(s) in non-compressed mode -----
void encodeStandard(char* fileName, int bits, char* overrideName)
{
	int lst;
	long  aa, bb;
	unsigned char a, b;
	size_t pos1, pos2 = 0;

	openInputFile(fileName);

	// Short header/2
	for (aa=0; aa <= 4000; aa++)	{B_ONE(bits);} // todo: let is last a fixed amount of time

	// 10 x 0xD0
	pos1 = ftell(outputFileHandle);
	for (aa=1; aa <= 10; aa++)		{K7(0xD0, bits);}

	// write the name of the file
	setCasFileName(overrideName == NULL  ? fileName : overrideName);

	casFileNameLen = 6;
	casFileName[casFileNameLen] = '\0';

	// Filename is only 6 letters + Cut the name after point.
	for (b=6; b > 0; b--)
	{
		if (casFileName[b] == '.')
		{
			casFileName[b] = '\0';
			casFileNameLen = b;
		}
	}

	if (overrideName)
	{
		printf("Loader named \"%s\"\t", casFileName);
	}
	else
	{
		printf("Converting:  \"%s\"\t", casFileName);
	}


	for (b=0; b < 6; b++)
	{
		if (b < casFileNameLen)		{a = casFileName[b];}
		else						{a = ' ';}
		K7(a, bits);
	}

	// space
	for (aa=1; aa <= 4000; aa++)
	{
		if (cdMode)		{putShort(bb0);}
		else			{putByte(b0);  }
	}

	// Short header/2
	for (aa=0; aa <= 4000; aa++)	{B_ONE(bits);}

	// Binary/Basic (tokenized) ?
	a = getByte();
	switch (a)
	{
		case TYPE_BINARY:

			printf("(BIN)");
			break;

		case TYPE_BASIC:

			printf("(BAS)");
			pos2 = ftell(outputFileHandle);
			fseek(outputFileHandle, pos1, SEEK_SET);
			for (aa=1; aa <= 10; aa++)	{K7(0xD3, bits);}
			fseek(outputFileHandle, pos2, SEEK_SET);
			break;

		default:
			exitOnError(14);
	}

	printf("... ");
	while (! endOfInputFile())
	{
		K7(getByte(), bits);
	}

	if (pos2 != 0)	{for (b=1; b<=7; b++)	{K7(0, bits);}}

	closeInputFile();
	printf("done.\n");
}

// ----- Build the encoding/decoding table for bit packing.
// ----- Works from given offset in file
void putEncodingTable(int offset, unsigned char bits)
{
	size_t storeFileOffset = inputFileOffset;
	int f = 1, v = 0, l = 1, x, y, i;
	unsigned char a, b;

	inputFileOffset = offset;

	// TABLE 255 x 3 cells (length,value,code,frequency)
	do
	{
		cells[f - 1][0] = l;
		cells[f - 1][1] = v;

		if (v == power2[l] - 1)
		{
			v = -1;
			l++;
		}
		f++;
		v++;
	}
	while (f != 257);

	for (i=0; i < 256; i++) // clean the char counters, init char codes
	{
		cells[i][3] = 0;
		cells[i][2] = i;
	}

	while (! endOfInputFile())
	{
		a = getByte();
		cells[a][3]++;
	}

	inputFileOffset = storeFileOffset;

	// SORTING
	for (a=0; a <= 254; a++)
	{
		for (b=0; b<=254; b++)
		{
			x = cells[b][3];
			y = cells[b + 1][3];

			if (x < y) // swap neighbours for [][2] and [][3]
			{
				cells[b][3] = y;
				cells[b + 1][3] = x;
				y = cells[b][2];
				cells[b][2] = cells[b + 1][2];
				cells[b + 1][2] = y;
			}
		}
	}

	// put conversion table into output WAV
	for (i=0; i < 256; i++)		{K7_c(cells[i][2], bits);}
}

// ----- Encode file in compressed or experimental mode -----
void encodeCompressed(char* fileName, char fileAttr, int bits, unsigned char endLoadFlag, int packFlag, int splittedPartNumber)
{
	int lst, i, mm, ss, l;
	int packedSize;
	long  aa, bb;
	unsigned char a, b;
	float l_ratio;

	// l_ratio counts how many bits were used, including start and stop bits.
	// I precalculated the bits used for filename and conversion table (not encoded): 2489 bits

	l_ratio = 2489;

	rewindInputFile();

	// Short header/2
	for (aa=0; aa <= 2400; aa++)
	{
		if (bits == 6 || bits == 8)		{B_ONE(8);}
		else							{B_ONE(bits);}
	}

	// INITIALIZE THE TABLE
	B_ERROR(bits);
	K7_c(0xD0, bits);
	K7_c(0xD0, bits);

    if (dosMode)	{K7_c(endLoadFlag, bits);}

	// write the name of the file
	setCasFileName(fileName);
	if (splittedPartNumber > 1)
	{
		printf("part No.%d of:\"%s\"\t", splittedPartNumber, casFileName);
	}
	else
	{
		printf("Converting:  \"%s\"\t", casFileName);
	}

	for (b=0; b < (dosMode ? 11 : 12); b++)
	{
		if (b < casFileNameLen)
		{
			a = casFileName[b];
		}
		else
		{
			a = ' ';
		}
		K7_c(a, bits);
	}

	// from here act according to the mode and type of file
	if (dosMode)
	{
		printf("(DOS)");

		// pack the COM and create self-extracting version
		packedSize = pack2BIN(inputMemPointer, inputFileLength, TYPE_DOS);
		if (stricmp(fileName + strlen(fileName) - 4, ".com") == 0 && packFlag)
		{
			if (packedSize < inputFileLength)
			{
				printf("\nConverted COM [%d bytes] -> self-extracting COM [%d bytes]\n", inputFileLength, packedSize);
				inputFileLength = packedSize;
				writePackedVersion(fileName, ".com");
			}
			else
			{
				printf("\nSFX COM is not created - packed file (%d) is bigger than original (%d)\n", packedSize, inputFileLength);
			}
		}
		inputFileLength = packedSize;

		putEncodingTable(0, bits);
	}
	else
	{
		// BINARY/ROM/BASIC(tokenized) ?
		a = getByte();
		switch (a)
		{
			case TYPE_BINARY:

				printf("(BIN");
				if (fileAttr == 'r')	printf(",r)");
				else					printf(",n)");

				putEncodingTable(7, bits);

				// HEADER - 7 BYTES
				K7_c(0xFE, bits);

				// start/end/exec addresses
				for (aa=1; aa <=6; aa++)
				{
					// zero start address means "load, but don't execute"
					if (aa > 4 && fileAttr != 'r')
					{
						getByte(); // drop input byte
						K7_c(0, bits);
					}
					else
					{
						K7_c(getByte(), bits);
					}
				}
				break;

			case TYPE_ROM:

				a = getByte();
				if (a == 0x42)
				{
					printf("(ROM)");

					if (fixMode)
					{
						int cd0024Counter = 0;

						patchROM(inputMemPointer);

						for (i=4; i < inputFileLength-3; i++)
						{
							if (inputMemPointer[i]   == 0xCD &&
								inputMemPointer[i+1] == 0x24 &&
								inputMemPointer[i+2] == 0x00)
							{
								inputMemPointer[i] = 0;
								inputMemPointer[i+1] = 0;
								cd0024Counter++;
							}
						}
						if (cd0024Counter > 0)
						{
							printf("\nPatched %d occurences of CALL 0024.\n", cd0024Counter);
						}

					}

					// pack the ROM and convert to BIN
					packedSize = pack2BIN(inputMemPointer, inputFileLength, TYPE_ROM);
					printf("\nConverted ROM [%d bytes] -> BIN [%d bytes]\n", inputFileLength, packedSize);
					inputFileLength = packedSize;

					// create the converted BIN version of the ROM
					if (inputMemPointer[1] + inputMemPointer[2]*256 >= 0x8000)
					{
						writePackedVersion(fileName, ".bin");
					}

					putEncodingTable(7, bits);

					// HEADER: 7 BYTES: 0xFE + start/end/exec addresses
					getByte(); // drop first 'FE' byte
					K7_c(0x41, bits);
					for (aa=0; aa < 6; aa++) { K7_c(getByte(), bits); }
				}
				break;

			case TYPE_BASIC:
				printf("(BAS)");

				if (inputFileLength > 2048) // pack only if > 2K
				{
					inputMemPointer[0] = 0;	// set the first byte in BASIC program area to zero
					// pack the BAS and convert to BIN
					packedSize = pack2BIN(inputMemPointer, inputFileLength, TYPE_BASIC);
					printf("\nConverted BAS [%d bytes] -> BIN [%d bytes]\n", inputFileLength, packedSize);
					inputFileLength = packedSize;
					// create the converted BIN version of the BAS
					writePackedVersion(fileName, ".bin");

					putEncodingTable(7, bits);

					// HEADER - 7 BYTES: 0xFE + start/end/exec addresses
					for (aa=0; aa < 7; aa++) { K7_c(getByte(), bits); }
				}
				else
				{
					putEncodingTable(1, bits);
					K7_c(0xFF, bits);
				}

				break;

			default: // COM ?
				if (strnicmp(casFileName+strlen(casFileName)-4, ".COM", 4) != 0)
				{
					exitOnError(14); // unsupported file type
				}
				printf("(COM)");

				// pack the COM and convert to BIN
				packedSize = pack2BIN(inputMemPointer, inputFileLength, TYPE_COM);
				printf("\nConverted COM [%d bytes] -> BIN [%d bytes]\n", inputFileLength, packedSize);
				inputFileLength = packedSize;

				// create the converted BIN version of the COM
				if (inputMemPointer[1] + inputMemPointer[2]*256 >= 0x8000)
				{
					writePackedVersion(fileName, ".bin");
				}

				putEncodingTable(7, bits);
				// HEADER - 7 BYTES: 0xFE + start/end/exec addresses
				for (aa=0; aa < 7; aa++) { K7_c(getByte(), bits); }
		}
	} // end-if-not-dosMode
	printf("... ");

	// encoding

	while (! endOfInputFile())
	{

		B_INITIAL(bits);
		l_ratio = l_ratio ++;

		a = getByte();
		b = 0;

		// a=value , l=number of digits
		while(TRUE)
		{
			if (cells[b][2] == a)
			{
				a = cells[b][1];
				l = cells[b][0] - 1;
				break;
			}
			b++;
		}

		do
		{
			if ((a & power2[l]) == 0)
			{
				B_ZERO(bits);
			}
			else
			{
				B_ONE(bits);
			}

			l_ratio++;
			l--;
		}
		while (l >= 0);

		B_ERROR(bits);
		l_ratio++;
	}

	printf("(compression rate: %2.0f%%)", l_ratio * 100.0 / (inputFileLength * 11.0));

	// END OF DATA
	for (a=1; a<=10; a++)
	{
		B_ONE(bits);
	}

	B_ERROR(bits);

	printf(" done.\n");
}

// =================== Print help info ===================
void printHelp()
{
   printf(" Usage:\n");
   printf("\n mwaver <baudrate|-cd> [-o wav][-c|-xp][-noldr][-nofix][-p len][-dos]");
   printf("\n   [-sine] <file> [-n] [file [-n]] ...");
   printf("\n where \n");
   printf("\n    baudrate - baud rate to be used in encoding.");
   printf("\n      Recommended values: standard mode - 1200 or 2400, usually 3200 is OK;");
   printf("\n      compressed mode: 3500 - 5500, experimental mode: 4500-5500");
   printf("\n    -cd  - create 44100Hz/16bit CD-compatible mono WAV output. Baud rate is");
   printf("\n      fixed (standard: 2205, compressed: 3675, experimental: 5512)");
   printf("\n    -o wav - name of WAV file to be created (./out.wav by default)");
   printf("\n    -c   - MicroWAVer's special WAV compression mode");
   printf("\n    -sine - use a sine waveform (if appropriate)");
   printf("\n    -xp  - experimental hi-speed mode (use at your own risk)");
   printf("\n    -noldr - don't attach to WAV the MicroWAVer's built-in loader");
   printf("\n    -nofix - don't patch ROM");
   printf("\n    -p <length of pause between files in milliseconds> (1000 by default)");
   printf("\n    file [-n] [file [-n] ...] - files to be encoded, -n - don't execute");
   printf("\n    -dos - convert files of any type to be loaded & saved to disk from DOS");
   printf("\n      Type keyword RAMDOS instead of file name to use the built-in RAM disk");
   printf("\n      Set number of 1<=VRAM<=7 and 1<RAM<=3 (8 max) pages for RAM disk");
   printf("\n      by using RAMDOS.vrs, where 'v'-no.of VRAM pages, 'r'-no.or RAM pages,");
   printf("\n      s-set it to 'n' to ensure that DOS files aren't loaded");
   printf("\n");
}

// Main routine ----------------------------------------------------------------

int main(int argc, char *argv[])
{
   unsigned char openFile, closeFile, lastFile;
   size_t origFileLength, blockStartOffset, blockFileLength;

   unsigned int l, i, fileArgs = 2;
   unsigned char bits;
   float time;

   printf("\n    _   _                  MicroWAVer 0.91 (c) 2005 WYZ & Cax");
   printf("\n   | | | | i c r o         All rights reserved.");
   printf("\n___| |_| |  _   ________   Encodes MSX files to WAV for loading");
   printf("\n         | | | |           via tape interface. Supported formats:");
   printf("\n         |_| |_| A V e r   ROM <= 48K, BIN, BAS (tokenized), COM");
   printf("\n");

	//Output help hint
   if (argc <= 1 || strcmp(argv[1], "-h") == 0 || strcmp(argv[1], "-?") == 0 || strcmp(argv[1], "/h") == 0 || strcmp(argv[1], "/?") == 0)
   {
      printHelp();
   	  exit(0);
   }

   // Check command line parameters
   if (argc < 3)
   {
	   printHelp();
	   exitOnError(2); // not enough arguments
   }

   if (strcmp(argv[1], "-cd") == 0)			{cdMode = TRUE;}
   else
   {
	   baudRate = atoi(argv[1]);
	   if (baudRate > 6000 || baudRate <= 0)
	   {
		   printHelp();
		   exitOnErrorText(1, argv[1]); // wrong baud speed
	   }

   	   ldrMode = FALSE; // in nocd mode loader attaching is not supported
   }

   for (i=2; i < argc; i++)
   {

	   if (*(unsigned char*)(argv[i]) != '-')
	   {
		   break;
	   }

	   if      (strcmp(argv[i], "-c") == 0)			{compressedMode = TRUE;}
	   else if (strcmp(argv[i], "-xp") == 0)		{experimentalMode = TRUE;}
	   else if (strcmp(argv[i], "-noldr") == 0)		{ldrMode = FALSE;}
	   else if (strcmp(argv[i], "-sine") == 0)		{sineMode = TRUE;}
	   else if (strcmp(argv[i], "-dos") == 0)		{dosMode = TRUE; }
   	   else if (strcmp(argv[i], "-nofix") == 0)		{fixMode = FALSE;}
	   else if (strcmp(argv[i], "-o") == 0)
	   {
		   if (argc == i + 1)
		   {
			   printHelp();
			   exitOnError(2); // incomplete command line
		   }
		   else
		   {
			   outputFileName = argv[++i];
			   fileArgs++;
	   	   }
	   }
	   else if (strcmp(argv[i], "-p") == 0)
	   {
		   if (argc == i + 1)
		   {
			   printHelp();
			   exitOnError(2); // incomplete command line
		   }
		   else
		   {
			   spaceTimeMs = atoi(argv[++i]);
			   fileArgs++;
	   	   }
	   }
	   else
	   {
		   printHelp();
		   exitOnErrorText(3, argv[i]); // unrecognized command line option argv[i]
	   }
	   fileArgs++;
   }

   if (dosMode) ldrMode = FALSE; // in dos & files-only mode loader is not needed

   if (sineMode)
   {
		WAVEFORM_SHORT_BLOAD = (experimentalMode ? WAVEFORM_SHORT_14_SINE : WAVEFORM_SHORT_20_SINE);
   }
   else
   {
		WAVEFORM_SHORT_BLOAD = (experimentalMode ? WAVEFORM_SHORT_14 : WAVEFORM_SHORT_20);
   }


   if (cdMode)
   {
	   if (experimentalMode)
	   {
			baudRate = 5512;
	   }
	   else if (compressedMode)
	   {
			baudRate = 3675;
	   }
	   else
	   {
			baudRate = 2205;
	   }
   }

   filesNumber=0;
   for (l=fileArgs; l < argc; l++)
   {
	   if (*(unsigned char*)(argv[l]) == '-')
	   {
	      if (strcmp(argv[l], "-n") == 0)
	      {
			fileExecAttrib[filesNumber-1] = 'n';
		  }
	      else if (strcmp(argv[l], "-r") == 0)
	      {
			fileExecAttrib[filesNumber-1] = 'r';
		  }
		  else
		  {
			printHelp();
			exitOnErrorText(6, argv[l]); // command line option argv[l] is not expected here
		  }
	   }
	   else
	   {
		   filesNumber++;
	   	   fileNamePointer[filesNumber-1] = argv[l];
	   	   fileExecAttrib[filesNumber-1] = 'r'; // executable by default
   	   }
   }

   if (filesNumber == 0 && ldrMode == 0)
   {
	   printHelp();
	   exitOnError(4); // nothing to encode
   }

   outputFileHandle = fopen(outputFileName, "wb");
   if (!outputFileHandle)				{exitOnErrorText(5, outputFileName);}

   printf("\n");
   if (cdMode) 			printf("CD-compatible; using fixed ");
   printf("baud rate=%d", baudRate);

   if (compressedMode)	 printf(", compressed mode");
   if (experimentalMode) printf(", experimental mode");
   if (filesNumber >= 2) printf("\nTime of pause between files: %d ms (%.1f sec)", spaceTimeMs, spaceTimeMs / 1000.0);

   printf("\nOutput file: %s\n\n", outputFileName);

   if (experimentalMode || compressedMode)
   {
	   	if (experimentalMode)			bits = WAVEFORM_BYTE_6;
	   	if (compressedMode)				bits = WAVEFORM_BYTE_8;
	   	if (cdMode)						bits = WAVEFORM_SHORT_12;
	   	if (cdMode && sineMode)			bits = WAVEFORM_SHORT_12_SINE;
	   	if (cdMode && experimentalMode)	bits = WAVEFORM_SHORT_8;

		header_wav();

		if (ldrMode)
		{
			encodeStandard("LOADER", WAVEFORM_SHORT_BLOAD, (filesNumber > 0 ? fileNamePointer[0] : "LOADER"));
			space(SHORT_PAUSE); // short space between loader and first file to load
		}

		for (i=0; i < filesNumber; i++)
		{
			openInputFile(fileNamePointer[i]);
			if (dosMode && inputFileLength > DOS_SPLIT_SIZE)
			{
				int splittedPartNumber = 1;
				unsigned char origFileBuf[inputFileLength];
				origFileLength = inputFileLength;
				memcpy(origFileBuf, inputMemPointer, inputFileLength);

				for (blockStartOffset=0; blockStartOffset < origFileLength; blockStartOffset += DOS_SPLIT_SIZE)
				{
					blockFileLength = (blockStartOffset+DOS_SPLIT_SIZE) >= origFileLength ? origFileLength - blockStartOffset : DOS_SPLIT_SIZE;
					inputFileLength = blockFileLength;
					memcpy(inputMemPointer, &origFileBuf[blockStartOffset], inputFileLength);

					openFile = (blockStartOffset == 0);
					closeFile = ((blockStartOffset+DOS_SPLIT_SIZE) >= origFileLength);
					lastFile = ((i == filesNumber-1) && closeFile) ;
					encodeCompressed(fileNamePointer[i], fileExecAttrib[i], bits, (1-lastFile) + 2*(1-openFile) + 4*(1-closeFile), FALSE, splittedPartNumber);
					splittedPartNumber++;
					if (blockFileLength / UNPACK_KB_PER_SEC > spaceTimeMs)
						 { space(blockFileLength / UNPACK_KB_PER_SEC); } // result in ms
					else { space(DEFINED_PAUSE); }
				}
			}
			else
			{
				blockFileLength = inputFileLength;
				encodeCompressed(fileNamePointer[i], fileExecAttrib[i], bits, (i == filesNumber-1) ? 0 : 1, TRUE, -1);
				if (strncmp(fileNamePointer[i], "RAMDOS", 6) == 0)
				{
					dosMode = TRUE;
					space((i == filesNumber-1) ? SHORT_PAUSE : 4000);
				}
				else
				{
					if (i != filesNumber-1)
					{
						if (blockFileLength / UNPACK_KB_PER_SEC > spaceTimeMs)
						     { space(blockFileLength / UNPACK_KB_PER_SEC); } // result in ms
						else { space(DEFINED_PAUSE); }
					}
				}
			}

			closeInputFile();
		} // end for filesNumber

		// kind-of-footer: sometimes CD or other players fade out
		// at the end of track and "eats" the end of data,
		// so I add some length to fix it.
		if (!(ldrMode && filesNumber == 0))
		{
			space(SHORT_PAUSE);
			for (i=0; i <= 500; i++)
			{
				if (bits == 6 || bits == 8)		{B_ONE(8);}
				else							{B_ONE(bits);}
			}
		}
   }
   else // not experimental or compressed mode
   {
		if (cdMode)		bits = WAVEFORM_SHORT_BLOAD;
		else			bits = WAVEFORM_BYTE_8;

		header_wav();

		for (i=0; i < filesNumber; i++)
		{
	   		encodeStandard(fileNamePointer[i], bits, NULL);
	   		space((i == filesNumber-1) ? SHORT_PAUSE : DEFINED_PAUSE);
		}
   }

   time = (lengthOfOutputFile() - 44) / (cdMode ? 44100 * 2.0 : baudRate * 8.0);
   printf("\nEnd of process ! Estimated loading time %d:%02d min (%.1f sec)\n",
   			((unsigned int)time) / 60, ((unsigned int)(time+0.5)) % 60, time);

   modifyWavHeader();

   cleanUp();
   return 0;
}

/* ---------------------------------------------------------------
						E		O		F
--------------------------------------------------------------- */
