	.LI OFF
	.CR Z80
	.OR $100
	.TF k7.com,BIN

;DEFICINICION DE CONSTANTES
;__________________________


FCB             .EQ     $005C           
DMA             .EQ     $0080    

TABLA           .EQ     $300
DATOS           .EQ     $400


		LD      DE,TITLE_TEXT           ;"MicroWAVer WYZ-2003" text
                LD      C,$09                   ;PUT STRING
                CALL    5

START:

 ; OPCIONES
 ;__________
  
                LD      BC,$20
                LD      HL,WW

OPCBC1:         IN      A,($AA)
                AND     $F0
                OR      6
                OUT     ($AA),A
                IN      A,($A9)
                          
                LD      (HL),12         ;CTRL
                CP      11111101B
                JR      Z,REINICIO
                
                LD      (HL),8	        ;F2
                CP      10111111B
                JR      Z,REINICIO
                
                LD      (HL),6		;F3
  		CP      01111111B
		JR      Z,REINICIO
                
                LD      (HL),0	        ;F1               
                CP      11011111B
                JR      Z,REINICIO

                IN      A,($AA)
                AND     $F0
                OR      7
                OUT     ($AA),A
                IN      A,($A9)
                
                CP      11101111B       ;STOP
                JP      Z,ERROR                
                
                IN      A,($A2)                 ;SI SUENA LA CABECERA INICIA AUTOSINCRO.
                XOR     B
                JP      P,OPCBC1
                LD      A,B
                CPL     
                LD      B,A
                DEC     C
                JR      NZ,OPCBC1    


REINICIO:
		LD      DE,LOADING_TEXT         ;Loading
                LD      C,$09                   ;PUT STRING
                CALL    5
                
; SINCRONIZACION
;_______________

E1:             LD      A,$08
                OUT     ($AB),A
                DI      
                LD      A,$0E
                OUT     ($A0),A
  
                LD      E,$00
                                     
COMIENZO:       LD      B,$F0           ;ESPERA CAMBIOS EN EL PUERTO                                        

M1B25:          
                IN      A,($A2)
                XOR     E
                JP      P,M1B25
                LD      A,E
                CPL     
                LD      E,A
                DJNZ    M1B25
                

                LD      B,80            ;CICLOS
                LD      C,0
M1B09:          IN      A,($A2)
                XOR     E
                JP      P,M1B17
                LD      A,E
                CPL     
                LD      E,A
                INC     C
                DJNZ    M1B09
                
                JR      MCONT_FIN     

M1B17:          NOP                      
                NOP     
                NOP     
                NOP     
                DJNZ    M1B09
      
MCONT_FIN:      LD      B,0             ;WINWIND=240\C
                LD      A,240
                
WWBC:           SBC     A,C
                JR      C,WWFIN
                INC     B
                JR      WWBC

WWFIN:
                LD      A,(WW)
                OR      A
                JR      NZ,USE_CHOSEN_WW
		LD      A,B		; use calculated WW
USE_CHOSEN_WW:
                LD      (WINWID),A
; ---------------------------------------------------------
; END of E1 routine
; ---------------------------------------------------------

INIBC0:         CALL    K7              ;ESPERA A QUE EMPIECEN LOS DATOS
                INC     A               ;SEAL ERROR
                JR      Z,INIBC0

INIBC1:         CALL    K7
                CP      $D0
                JR      Z,INIBC1

;NOMBRE DEL ARCHIVO
;__________________

	        ld      (ENDLOAD_FLAG),A

                LD      HL,FCB		; will be incremented before puting data
                LD      B,11
                
NABC0:          CALL    K7
                OUT     ($98),A
                INC     HL
	        LD      (HL),A
                DJNZ    NABC0
 

;CARGA TABLA DE CONVERSION
;_________________________
;
; 256 BYTES

; LD B,0 - B is zero bebause of previous DJNZ
                LD      HL,TABLA
CTBC0:          CALL    K7
                
                LD      (HL),A
                INC     HL
                DJNZ    CTBC0

                
;CARGAR DATOS
;____________
             
                LD      BC,DATOS
                                                
C.DBC0:         CALL    K7_COD
                JR      C,C.DBC_FIN0
                LD      (BC),A
                INC     BC
                JR      C.DBC0

C.DBC_FIN0:                             ;ERROR DE CARGA?
                CP      11
                JR      C,NO_ERROR

;ERRORES
;_______

ERROR:          LD      BC,$0698
                LD      HL,ERR1
                OTIR
                               
MOTOR_OFF:      LD      A,$09
                OUT     ($AB),A
                RET               	; MOTOR_OFF is a stand-alone routine
                
NO_ERROR:
                PUSH    BC

                LD      BC,$0598        ;SIN ERROR
                LD      HL,OK
                OTIR
                              
               
;DECODIFICAR DATOS
;_________________
                                
                LD      BC,DATOS
                POP     HL		; get the PUSH BC value
	        xor     A		; erase C flag
                SBC     HL,BC
                
;DECODIFICADOR
;_____________

;LA TABLA DEBE ESTAR EN UNA DIRECCION MULTIPLO DE &H100
;(BC)=DIR INICIAL (HL)=LONGITUD

DECODE_LOOP:    LD      DE,TABLA
                LD      A,(BC)
                ADD     A,E
                LD      E,A
                LD      A,(DE)
                LD      (BC),A
                INC     BC
                DEC     HL
                LD      A,H
                CP      $FF
                JR      NZ,DECODE_LOOP
              
           	CALL    MOTOR_OFF

; --- execute unpacking ---
		LD      HL,DATOS
		CALL    DATOS+3 
                LD      (LEN_DATOS),HL
;GUARDAR
;_______
                   
                 LD      A,(ENDLOAD_FLAG)  ; is this file last in multifile ?
                 BIT     1,A
		 JR      NZ,SKIP_OPEN     ; if bit1 = 0 (z is on) => open file

;PREPARE FCB
;__________

		 LD      HL,FCB+12
                 LD      B,37-12
                 XOR     A
                
ABUC:            LD      (HL),A
                 INC     HL
                 DJNZ    ABUC
                                
                 LD      DE,FCB
		 LD      (DE),A
                 LD      C,$16             ; CREA ARCHIVO
                 CALL    5
 
                 AND     A
                 JR      NZ,ERROR          ; ERROR: can't open file
 
SKIP_OPEN:	
                 LD      DE,DATOS          ; DATOS
                 LD      C,$1A             ; SET DMA
                 CALL    5
                                 
                 LD      HL,$0001
                 LD      (FCB+$E),HL       ; SET RECORD LENGTH

	         LD      HL,(LEN_DATOS)
                 LD      DE,FCB
                 LD      C,$26             ; SERIAL WRITE
                 CALL    5
                 
                 LD      A,(ENDLOAD_FLAG)  ; is this file last in multifile ?
                 BIT     2,A
		 JR      NZ,SKIP_CLOSE     ; if bit2 = 0 (z is on) => close file
                 
                 LD      DE,FCB            ; CLOSE FILE
                 LD      C,$10
                 CALL    5
SKIP_CLOSE:                
                 LD      A,(ENDLOAD_FLAG)  ; is this file last in the sequence ?
                 RRCA
                 JP      C,START	   ; if bit0 = 0 => end of loading

                 RET                
                
;LEE 1 BYTE DESDE K7
;___________________

; RET: (A)
;
; PARA LA TABLA DE CONVERSION


K7:             EXX
                CALL    F_BIOS          ;D=VALOR
                                        ;L=N DE BITS
                                     
K7RETARDO:
                LD      A,D
                EXX
                RET

;LEE 1 BYTE CODIFICADO DESDE K7
;______________________________

; RET: (A)
;
; PARA EL RESTO DE LOS DATOS


K7_COD:         EXX
                CALL    F_BIOS          ;D=VALOR
                                        ;L=N DE BITS
                                        
                LD      A,L
                CP      9
                JR      NC,STOP
                
                                     
K7CRETARDO:
                LD      H,0
                LD      BC,PREDEFINIDA
                ADD     HL,BC
                LD      A,(HL)
                ADD     A,D
                EXX
                RET

STOP:           EXX

                SCF
                RET                


; FUNCION DE CARGA DESDE CASSETTE
;_________________________________


;* LINEAS MODIFICADAS           


F_BIOS:
J1AC0:
                IN      A,($A2)
                RLCA    
                JR      NC,J1AC0

J1AC9:
                IN      A,($A2)
                RLCA    
                JR      C,J1AC9
                
                LD      E,$00
J1B25:
                IN      A,($A2)
                XOR     E
                JP      P,J1B25
                LD      A,E
                CPL     
                LD      E,A
                
                LD      D,0             ;LINEA AADIDA
                LD      L,0
                
J1AE6:          

; Contador FSK
; PORT.A2         I AY-3-8910 PSG       lectura de datos


J1B03:          LD      A,(WINWID)
                LD      B,A
                LD      C,0
J1B09:          IN      A,($A2)
                XOR     E
                JP      P,J1B17
                LD      A,E
                CPL     
                LD      E,A
                INC     C
                DJNZ    J1B09
                JP      CONT_FIN     

;__________________________________________

J1B17:          NOP                      
                NOP     
                NOP     
                NOP     
                DJNZ    J1B09
CONT_FIN:       LD      A,C

;__________________________________________

                CP      $04             ;BIT=1?
                                        ;CCF     
                RET     NC              ;RET    C       ERROR SI A>4 => FIN DE DATOS

                CP      $02             ;BIT=0?
                CCF     
                RL      D               ;RR D
                                        ;LD      A,C
                                        
                LD      A,C
                RRCA                    ;ES IMPAR?
                
                JR      C,L1B25         ;IMPAR
                
K1B25:          IN      A,($A2)
                XOR     E
                JP      P,K1B25
                LD      A,E
                CPL     
                LD      E,A
                
L1B25:          IN      A,($A2)
                XOR     E
                JP      P,L1B25
                LD      A,E
                CPL     
                LD      E,A                
                
                
                INC     L               ;*DEC L
                JP      NZ,J1AE6

                LD      A,D
                RET
                                
;TABLAS
;______

                
PREDEFINIDA:    .DB      0,0,2,6,14,30,62,126,254


TITLE_TEXT:     .AS      "MicroWAVerDOS-2005$"
LEN_DATOS       .EQ      TITLE_TEXT
ENDLOAD_FLAG    .EQ      TITLE_TEXT+2
WW              .EQ      TITLE_TEXT+3
WINWID          .EQ      TITLE_TEXT+4

LOADING_TEXT:   .DB      $0D,$0A,"Loading:$"

ERR1:           .AS      " <Err>"
OK:             .AS      " <OK>"


                